/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package vue;
import java.awt.Point;
import java.sql.*;
import javax.swing.DefaultComboBoxModel;
import java.lang.String.*;
import java.util.ArrayList;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.DefaultTableModel;
import modele.metier.*;
import modele.dao.*;
import java.awt.event.MouseListener;
/**
 *
 * @author Mathias
 */
public class ListeStage extends javax.swing.JFrame {
    private DefaultTableModel modeleTable;
    /**
     * Creates new form ListeStage
     */
    public ListeStage() {
        
        int cas = 0;
        String classe = "";
        String etudiant = "";
        String prof = "";
        String annee = "";
        
        initComponents();
        EcouteurSouris unEcouteurSouris = new EcouteurSouris();
        jTableStageDef.addMouseListener(unEcouteurSouris);
    }
    
    
 private class EcouteurSouris implements MouseListener {
 public void mouseClicked(MouseEvent evt) {
 if (evt.getSource().equals(jTableStageDef)) {
 // repérer la ligne et la colonne du point cliqué
 Point p = evt.getPoint();
 int numColonne = jTableStageDef.columnAtPoint(p);
 int numLigne = jTableStageDef.rowAtPoint(p);
 String Newligne=System.getProperty("line.separator");
 // extraire l'information du modèle et l'afficher
 String idStage = modeleTable.getValueAt(numLigne, 8).toString();
 String titre = "Détails du stage";
 StageDefinitif Stage = null;
 int idStagei = Integer.parseInt(idStage);
     try {
         Stage = StageDAO.getOneById(idStagei);
     } catch (SQLException ex) {
         Logger.getLogger(ListeStage.class.getName()).log(Level.SEVERE, null, ex);
     }
JOptionPane.showMessageDialog(null,"Nom de l'étudiant : "+ Stage.getlEtudiant().getNom() + Newligne + "Prénom Étudiant : " + Stage.getlEtudiant().getPrenom() + Newligne + "Date de Début du stage : " + Stage.getDateDeb() + Newligne + "Date de Fin de stage : " + Stage.getDateFin() + Newligne + "Détails du Stage : " + Stage.getContenu());

 }
 
 }

        @Override
        public void mousePressed(MouseEvent e) {
          
        }

        @Override
        public void mouseReleased(MouseEvent e) {
           
        }

        @Override
        public void mouseEntered(MouseEvent e) {
            
        }

        @Override
        public void mouseExited(MouseEvent e) {
         
        }
 }
 
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanelMain = new javax.swing.JPanel();
        jLabelClasse = new javax.swing.JLabel();
        jLabelEtudiant = new javax.swing.JLabel();
        jLabelProf = new javax.swing.JLabel();
        jLabelAnnee = new javax.swing.JLabel();
        textFieldEtudiantNom = new java.awt.TextField();
        textFieldProfNom = new java.awt.TextField();
        jLabelStageDef = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableStageDef = new javax.swing.JTable();
        jComboBoxClasse = new javax.swing.JComboBox<>();
        jComboBoxAnnee = new javax.swing.JComboBox<>();
        jButton1 = new javax.swing.JButton();
        jLabelTest = new javax.swing.JLabel();
        textFieldEtudiantPrenom = new javax.swing.JTextField();
        textFieldProfPrenom = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabelClasse.setText("Classe");

        jLabelEtudiant.setText("Nom étudiant");

        jLabelProf.setText("Nom prof en charge");

        jLabelAnnee.setText("Année");

        textFieldProfNom.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textFieldProfNomActionPerformed(evt);
            }
        });

        jLabelStageDef.setText("Stage Définitif");

        modeleTable = new DefaultTableModel();
        jTableStageDef.setModel(modeleTable);
        String[]titresCol={"Étudiant","Entreprise","Date Débit","Date Fin", "Prof Principal", "Référent", "Année ","Classe","Id"};
        modeleTable.setColumnIdentifiers(titresCol);
        jTableStageDef.setEnabled(false);
        jScrollPane1.setViewportView(jTableStageDef);

        jButton1.setText("Rechercher");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        textFieldEtudiantPrenom.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textFieldEtudiantPrenomActionPerformed(evt);
            }
        });

        jLabel1.setText("Prénom étudiant");

        jLabel2.setText("Prénom prof en charge");

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTable1.setEnabled(false);
        jScrollPane2.setViewportView(jTable1);

        javax.swing.GroupLayout jPanelMainLayout = new javax.swing.GroupLayout(jPanelMain);
        jPanelMain.setLayout(jPanelMainLayout);
        jPanelMainLayout.setHorizontalGroup(
            jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelMainLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1))
            .addGroup(jPanelMainLayout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelClasse)
                    .addComponent(jComboBoxClasse, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(80, 80, 80)
                .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabelEtudiant)
                    .addComponent(textFieldEtudiantNom, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE)
                    .addComponent(textFieldEtudiantPrenom, javax.swing.GroupLayout.Alignment.TRAILING))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(textFieldProfNom, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabelProf, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(107, 107, 107)
                        .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jComboBoxAnnee, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelAnnee, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(textFieldProfPrenom, javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addGap(22, 22, 22))
            .addGroup(jPanelMainLayout.createSequentialGroup()
                .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addGap(122, 122, 122)
                        .addComponent(jLabelTest, javax.swing.GroupLayout.PREFERRED_SIZE, 665, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addGap(405, 405, 405)
                        .addComponent(jButton1))
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabelStageDef))
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addGap(148, 148, 148)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 0, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(115, Short.MAX_VALUE))
        );
        jPanelMainLayout.setVerticalGroup(
            jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelMainLayout.createSequentialGroup()
                .addGap(41, 41, 41)
                .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelEtudiant)
                            .addComponent(jLabelClasse)
                            .addComponent(jLabelProf))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(textFieldEtudiantNom, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(textFieldProfNom, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jComboBoxClasse, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addComponent(jLabelAnnee)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jComboBoxAnnee, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanelMainLayout.createSequentialGroup()
                                .addGap(136, 136, 136)
                                .addComponent(jButton1)
                                .addGap(72, 72, 72))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelMainLayout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jLabelStageDef)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                        .addComponent(jLabelTest))
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanelMainLayout.createSequentialGroup()
                                .addGap(27, 27, 27)
                                .addComponent(jLabel1))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelMainLayout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel2)))
                        .addGap(18, 18, 18)
                        .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(textFieldEtudiantPrenom, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(textFieldProfPrenom, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(58, 58, 58)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 375, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        try{
            jComboBoxClasse.addItem("Aucune");
            ArrayList<Classe> S1 = ClasseDAO.getAll();
            for (int i = 0; i< S1.size(); i++) {
                String des = S1.get(i).getNom();
                jComboBoxClasse.addItem(des);
            }  } catch (SQLException ex)
            {
                String test  = ex.getMessage();
                jComboBoxClasse.addItem(test);
            }
            try{
                jComboBoxAnnee.addItem("Aucune");
                ArrayList<Annee> S1 = AnneeDAO.getAll();
                for (int i = 0; i< S1.size(); i++) {
                    String des = S1.get(i).getAnnee();
                    jComboBoxAnnee.addItem(des);
                }  } catch (SQLException ex)
                {
                    String test  = ex.getMessage();
                    jComboBoxAnnee.addItem(test);
                }

                javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
                getContentPane().setLayout(layout);
                layout.setHorizontalGroup(
                    layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanelMain, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                );
                layout.setVerticalGroup(
                    layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanelMain, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                );

                pack();
            }// </editor-fold>//GEN-END:initComponents
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        for(int i = modeleTable.getRowCount(); i > 0; --i)
        modeleTable.removeRow(i-1);
        String classe;
        String etudiantNom;
        String profNom;
        String etudiantPre;
        String profPre;
        String annee;
        if("Aucune".equals(jComboBoxClasse.getSelectedItem().toString()))
        {
            classe = null;
        }
        else
        {
            classe = jComboBoxClasse.getSelectedItem().toString();
        }
        etudiantNom = textFieldEtudiantNom.getText();
        etudiantPre = textFieldEtudiantPrenom.getText();
        profNom = textFieldProfNom.getText();
        profPre = textFieldProfPrenom.getText();
        if("Aucune".equals(jComboBoxAnnee.getSelectedItem().toString()))
        {
            annee = null;
        }
        else
        {
            annee = jComboBoxAnnee.getSelectedItem().toString();
        }
        ArrayList<StageDefinitif> listeStages = new ArrayList<>();
        try {
            listeStages = StageDAO.getAllStageDefActuels(classe,etudiantNom, etudiantPre, profNom, profPre, annee);
        } catch (SQLException ex) {
            Logger.getLogger(ListeStage.class.getName()).log(Level.SEVERE, null, ex);
        }
        //String msg = "classe : " + classe + " annee : "+ annee + " étudiant : " + etudiantNom + " " + etudiantPre + " prof : " + profNom + " " + profPre;
        //jLabelTest.setText(msg);
        String[] ligneTable = new String[9];
        for (int i=0; i < listeStages.size(); i++ ){
            //Classe Classe = listeStages.get(i).getlEtudiant().getLaClasse();
            ligneTable[0] = listeStages.get(i).getlEtudiant().getPrenom() + " " + listeStages.get(i).getlEtudiant().getNom();
            ligneTable[1] = listeStages.get(i).getlEntreprise().getNom();
            ligneTable[2] = listeStages.get(i).getDateDeb().toString();
            ligneTable[3] = listeStages.get(i).getDateFin().toString();
            ligneTable[4] = listeStages.get(i).getLenseignant().getPrenom() + " " + listeStages.get(i).getLenseignant().getNom();
            ligneTable[5] = listeStages.get(i).getLeReferent().getNom() + " " + listeStages.get(i).getLeReferent().getPrenom();
            ligneTable[6] = listeStages.get(i).getlAnnee().getAnnee();
            ligneTable[7] = listeStages.get(i).getlEtudiant().getLaClasse().getNom();
            ligneTable[8] = String.valueOf(listeStages.get(i).getIdStageDef());
            modeleTable.addRow(ligneTable);
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void textFieldProfNomActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textFieldProfNomActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_textFieldProfNomActionPerformed

    private void textFieldEtudiantPrenomActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textFieldEtudiantPrenomActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_textFieldEtudiantPrenomActionPerformed
    private static DefaultComboBoxModel modeleCombo = new DefaultComboBoxModel();
    private static Classe uneClasse;

    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */


        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ListeStage.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ListeStage.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ListeStage.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ListeStage.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ListeStage().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JComboBox<String> jComboBoxAnnee;
    private javax.swing.JComboBox<String> jComboBoxClasse;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabelAnnee;
    private javax.swing.JLabel jLabelClasse;
    private javax.swing.JLabel jLabelEtudiant;
    private javax.swing.JLabel jLabelProf;
    private javax.swing.JLabel jLabelStageDef;
    private javax.swing.JLabel jLabelTest;
    private javax.swing.JPanel jPanelMain;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTableStageDef;
    private java.awt.TextField textFieldEtudiantNom;
    private javax.swing.JTextField textFieldEtudiantPrenom;
    private java.awt.TextField textFieldProfNom;
    private javax.swing.JTextField textFieldProfPrenom;
    // End of variables declaration//GEN-END:variables

    /*jPanel1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jIdNewActionPerformed(evt);
            }
        });*/




}
